#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>

//#define PRINTABLE_ESCAPE
//#define PASS_UNKNOWN_ESCAPES
//does not work with listen port==0 since stdout is closed
//#define PRINT_UNKNOWN_ESCAPES

#define vsnd(msg,len) send(lsock,msg,len,0); l=i=0;

void resolve_address(struct sockaddr_in *addr,char *hostname,unsigned short port);
void to_vt100(char ch);
void from_vt100(char ch);

int lsock,sock;

void main(int argc,char **argv)
{
	char c;
	int laddrlen,lport,port=23;
	struct sockaddr_in laddr,addr;
	fd_set fds;

	if(argc<3||argc>5)
	{
		printf("VT100 emulator for IBM3164 dumb terminals (and probably others by IBM)\n");
		printf("     by ARK (root@ark.wtfe.org,ark@lhq.com)\n\n");
		printf("use: ibm3164_to_vt100 (listen port) (host) [port (default 23) [-c]]\n");
		printf("     if listen port is 0, a dynamic port is chosen,\n");
		printf("     and the port number is printed to stdout.\n");
		printf("     -c trys to set the terminal into char mode with\n");
		printf("     a 6 byte string of telnet codes.\n");
		return;
	}
	lport=atoi(argv[1]);
	if(argc>=4)
		port=atoi(argv[3]);

	sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	resolve_address(&laddr,"127.0.0.1",lport);
	if(bind(sock,(struct sockaddr *)&laddr,sizeof(struct sockaddr)))
	{
		perror("bind()");
		return;
	}
	listen(sock,0);
	if(!lport)
	{
		laddrlen=sizeof(struct sockaddr);
		getsockname(sock,(struct sockaddr *)&laddr,&laddrlen);
		printf("%d",lport=ntohs(laddr.sin_port));
		fflush(stdout);
		fclose(stdout); //so that something like
				//telnet localhost `ibm3164_to_vt100 0 host &`
				//will work properly
	}
	laddrlen=sizeof(struct sockaddr);
	lsock=accept(sock,(struct sockaddr *)&laddr,&laddrlen);
	close(sock);

	sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	resolve_address(&addr,argv[2],port);
	if(connect(sock,(struct sockaddr *)&addr,sizeof(struct sockaddr)))
	{
		perror("connect()");
		return;
	}

	//DO ECHO DO SGA WILL ECHO WILL SGA
	if(argc>=5&&argv[4][0]=='-'&&argv[4][1]=='c')
	{
		send(sock,"\xFF\xFD\x03\xFF\xFD\x01\xFF\xFB\x03\xFF\xFB\x01",12,0);
		send(lsock,"\xFF\xFD\x03\xFF\xFD\x01\xFF\xFB\x03\xFF\xFB\x01",12,0);
	}

	for(;;)
	{
		FD_ZERO(&fds);
		FD_SET(lsock,&fds);
		FD_SET(sock,&fds);
		select((sock>lsock?sock:lsock)+1,&fds,NULL,NULL,NULL);

		if(FD_ISSET(lsock,&fds)) //from localhost to remote host
		{
			if(recv(lsock,&c,1,0)<1) break;
			to_vt100(c);
		}

		if(FD_ISSET(sock,&fds)) //from remote host to localhost
		{
			if(recv(sock,&c,1,0)<1) break;
			from_vt100(c);
		}
	}

	shutdown(lsock,2);
	shutdown(sock,2);
	close(lsock);
	close(sock);
}

void resolve_address(struct sockaddr_in *addr,char *hostname,unsigned short port)
{
	struct hostent *host;

	bzero((char *)addr,sizeof(struct sockaddr_in));
	addr->sin_family=AF_INET;
	addr->sin_port=htons(port);
	addr->sin_addr.s_addr=inet_addr(hostname);
	if((int)addr->sin_addr.s_addr==-1)
	{
		host=gethostbyname(hostname);
		if(host)
		{
			bcopy(host->h_addr,(char *)&addr->sin_addr,host->h_length);
		}
		else
		{
			printf("Couldn't resolve address!\n");
			exit(-1);
		}
	}
}

void to_vt100(char ch)
{
	send(sock,&ch,1,0);
}

void from_vt100(char ch)
{
	static char c[256],*p,attr=0;
	static unsigned char l=0;
	static enum state {NADA,TEL_ESC,TEL_2,TEL_SUBNEG,
		VT_ESC,VT_BRKT,VT_CHAIN} i=NADA;
	int x=0,y=0;

	c[l++]=ch;
	switch(i)
	{
		case NADA:
		switch(ch)
		{
			case '\377':
			i=TEL_ESC;
			break;

			case '\033':
#ifdef PRINTABLE_ESCAPE
			c[0]='{';
#endif
			i=VT_ESC;
			break;

			default:
			vsnd(c,l);
		}
		break;

		case TEL_ESC:
		switch(ch)
		{
			case '\372':
			i=TEL_SUBNEG;
			break;

			default:
			i=TEL_2;
		}
		break;

		case TEL_2:
		vsnd(c,l);
		break;

		case TEL_SUBNEG:
		if(ch=='\360'&&c[l-2]=='\377')
		{
			vsnd(c,l);
		}
		break;

		case VT_ESC:
		switch(ch)
		{
			//set tab
			case 'H': vsnd("\x1B""0",2); break;

			case '[':
			i=VT_BRKT;
			break;

			case '=':
			vsnd("\x1B\"s",3);
			break;

			default:
#ifdef PRINT_UNKNOWN_ESCAPES
			c[l]=0;			
			printf("UNKNOWN ESCAPE (%s)\n",c);
#endif
#ifdef PASS_UNKNOWN_ESCAPES
			vsnd(c,l);
#else
			l=i=0;
#endif
		}
		break;

		case VT_BRKT:
		switch(ch)
		{
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ';':
			case '?':
			i=VT_CHAIN;
			break;

			//cursor movement
			case 'A': vsnd("\x1B""A",2); break;
			case 'B': vsnd("\x1B""B",2); break;
			case 'C': vsnd("\x1B""C",2); break;
			case 'D': vsnd("\x1B""D",2); break;

			//cursor home
			case 'H': vsnd("\x1BH",2); break;

			//erase to end of page
			case 'J': vsnd("\x1BJ",2); break;

			//erase to end of line
			case 'K': vsnd("\x1BI",2); break;

			//reset attributes
			case 'm': attr=0; vsnd("\x1B""4@",3); break;

			default:
#ifdef PRINT_UNKNOWN_ESCAPES
			c[l]=0;			
			printf("UNKNOWN ESCAPE (%s)\n",c);
#endif
#ifdef PASS_UNKNOWN_ESCAPES
			vsnd(c,l);
#else
			l=i=0;
#endif
		}
		break;

		case VT_CHAIN:
		switch(ch)
		{
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ';':
			case '?':
			//continue with chain
			break;

			//cursor movement
			case 'A':
			sscanf(c+2,"%d",&x);
			while(x--)
				vsnd("\x1B""A",2);
			break;
			case 'B':
			sscanf(c+2,"%d",&x);
			while(x--)
				vsnd("\x1B""B",2);
			break;
			case 'C':
			sscanf(c+2,"%d",&x);
			while(x--)
				vsnd("\x1B""C",2);
			break;
			case 'D':
			sscanf(c+2,"%d",&x);
			while(x--)
				vsnd("\x1B""D",2);
			break;

			case 'H': //cursor placement
			case 'f':
			sscanf(c+2,"%d;%d",&y,&x);
			//as far as i know, it can only do 80x24
			//and complains if the cursor is set outside
			if(x<0) x=0;
			if(x>79) x=79;
			if(y<0) y=0;
			if(y>23) y=23;
			sprintf(c,"\x1BY%c%c",y+32,x+32);
			vsnd(c,strlen(c));
			break;

			case 'J':
			sscanf(c+2,"%d",&x);
			switch(x)
			{
				//clear to end of screen
				case 0: vsnd("\x1BJ",2); break;
				//clear from home to cursor
				//*defective* clears entire screen
				case 1: vsnd("\x1BL",2); break;
				//clear entire screan
				case 2:
				default: vsnd("\x1BL",2); break;
			}
			break;

			case 'K':
			sscanf(c+2,"%d",&x);
			switch(x)
			{
				//clear to end of line
				case 0: vsnd("\x1BJ",2); break;
				//clear from start of line to cursor
				//*defective* clears entire line
				case 1: vsnd("\x1BO\x1BN",4); break;
				//clear entire line
				case 2:
				default: vsnd("\x1BO\x1BN",4); break;
			}
			break;

			case 'g':
			sscanf(c+2,"%d",&x);
			switch(x)
			{
				//clear all tab stops
				case 3: vsnd("\x1B 1",3); break;

				//clear current tab stop
				case 0:
				default: vsnd("\x1B""1",2); break;
			}
			break;

			case 'm': //attribute/color
			c[l-1]=0;
			*(p=c+1)=';';
			while((p=strchr(p,';'))!=NULL)
			{
				sscanf(++p,"%d",&x);
				switch(x)
				{
					case 0: attr=0; break; //off
					case 1: attr|=0x08; break; //bold
					case 4: attr|=0x02; break; //underscore
					case 5: attr|=0x04; break; //blink
					case 7: attr|=0x01; break; //reverse
					case 8: attr|=0x10; break; //hide

					default: //if somebody wants to keep
						//track of setting program
						//color mode in control 2
						//command, ansi color code
						//emulation could be added.
				}
			}
			sprintf(c,"\x1B""4%c",attr|0x40);
			vsnd(c,3);
			break;

			default:
#ifdef PRINT_UNKNOWN_ESCAPES
			c[l]=0;			
			printf("UNKNOWN ESCAPE (%s)\n",c);
#endif
#ifdef PASS_UNKNOWN_ESCAPES
			vsnd(c,l);
#else
			l=i=0;
#endif
		}
		break;
	}
}
